=== docs/requirements.txt ===
# Standard requirements
sphinx
sphinx-rtd-theme

# Specific requirements for this project
adb-shell[async,usb]
pycryptodome
