=== debian/changelog ===
python-adb-shell (0.4.4-3) unstable; urgency=medium

  [ Thomas Goirand ]
  * Replaced python3-libusb1 by python3-usb1 (Closes: #1086887).

  [ Edward Betts ]
  * Fix test failure with Python 3.13+. (Closes: #1082192)
  * Add my name to copyright and uploaders.
  * Add dh-sequence-python3 and pybuild-plugin-pyproject to Build-Depends.
  * Remove 'Priority: optional', now the default.
  * Update Standards-Version.
  * Update debian/watch to format version 5 and switch from PyPI to GitHub.
  * Add debian/salsa-ci.yml.

 -- Edward Betts <edward@4angle.com>  Sun, 08 Feb 2026 10:22:59 +0000

python-adb-shell (0.4.4-2) unstable; urgency=medium

  * Reupload source-only.

 -- Thomas Goirand <zigo@debian.org>  Wed, 07 Aug 2024 09:45:54 +0200

python-adb-shell (0.4.4-1) unstable; urgency=medium

  * Initial release. (Closes: #1076979)

 -- Thomas Goirand <zigo@debian.org>  Wed, 24 Jul 2024 13:22:05 +0200
