=== debian/control ===
Source: python-adb-shell
Section: python
Maintainer: Home Assistant Team <team+homeassistant@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Edward Betts <edward@4angle.com>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 openstack-pkg-tools,
 pybuild-plugin-pyproject,
 python3-all,
 python3-setuptools,
Build-Depends-Indep:
 python3-aiofiles,
 python3-async-timeout,
 python3-cryptography,
 python3-pyasn1,
 python3-pycryptodome,
 python3-pytest,
 python3-rsa,
 python3-usb1,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/homeassistant-team/deps/python-adb-shell
Vcs-Git: https://salsa.debian.org/homeassistant-team/deps/python-adb-shell.git
Homepage: https://github.com/JeffLIrion/adb_shell

Package: python3-adb-shell
Architecture: all
Depends:
 python3-cryptography,
 python3-pyasn1,
 python3-rsa,
 ${misc:Depends},
 ${python3:Depends},
Description: implementation of ADB with shell and FileSync functionality
 This Python package implements ADB shell and FileSync functionality.
 .
 This package contains the Python 3.x module.
