=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/JeffLIrion/adb_shell
include /usr/share/openstack-pkg-tools/pkgos.make

export PYBUILD_TEST_ARGS= -v

%:
	dh $@ --buildsystem=pybuild

override_dh_fixperms:
	dh_fixperms
	rm -f $(CURDIR)/debian/python3-adb-shell/usr/lib/python3/dist-packages/NOWHERE
