=== debian/watch ===
Version: 5

Template: Github
Owner: JeffLIrion
Project: adb_shell
